"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setupMockFunctionExecution = void 0;
const case_core_plugin_function_dsl_1 = require("@contract-case/case-core-plugin-function-dsl");
const case_plugin_base_1 = require("@contract-case/case-plugin-base");
const setupMockFunctionExecution = ({ request: expectedArguments, response: returnValue }, parentContext) => Promise.resolve((0, case_plugin_base_1.addLocation)('mockFunction', parentContext)).then((context) => {
    // create mock function
    let data = null;
    const f = (...actualArguments) => {
        data = { actualArguments };
        context.logger.debug('Mock function was invoked with arguments:', actualArguments);
        const strippedReturnValue = context.descendAndStrip(returnValue, (0, case_plugin_base_1.addLocation)('returnValue', context));
        context.logger.debug('Returning', strippedReturnValue);
        return strippedReturnValue;
    };
    return {
        config: {
            '_case:mock:type': case_core_plugin_function_dsl_1.MOCK_FUNCTION_EXECUTION,
            variables: context['_case:currentRun:context:variables'],
            invokeable: f,
        },
        assertableData: () => Promise.resolve(data).then((result) => {
            if (data == null) {
                context.logger.debug('The mock function appears not to have been invoked');
            }
            return {
                actual: result ? result.actualArguments : null,
                context: (0, case_plugin_base_1.addLocation)('arguments', context),
                expected: expectedArguments,
            };
        }),
    };
});
exports.setupMockFunctionExecution = setupMockFunctionExecution;
//# sourceMappingURL=mockFunctionExecution.js.map